unit EditReal;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  IntegLen = 1..65000;
  TEditReal = class(TEdit)
  private
    { Private declarations }
    FDecimals:Word;
    FIntLen:IntegLen;
    FDecPoint:AnsiChar;
    procedure KeyPress(var Key: Char); override;
  protected
    { Protected declarations }
  public
    constructor Create(AOwner: TComponent); override;
    function SetText(Txt : String):boolean;
    { Public declarations }
  published
    Property Decimals : Word read FDecimals write FDecimals default 2;
    Property IntLen : IntegLen read FIntLen write FIntLen default 10;
    Property DecPoint : AnsiChar read FDecPoint write FDecPoint default '.';
    { Published declarations }
  end;

procedure Register;

implementation

constructor TEditReal.Create(AOwner: TComponent);
begin
   inherited Create(AOwner);
   Decimals:=2;
   IntLen:=10;
   DecPoint:='.';
   Text:='1';
end;

procedure TEditReal.KeyPress(var Key: Char);
begin
   if (Key = DecPoint) and (Decimals=0) then Key:=#0;
   if (Key = DecPoint) and (Pos(DecPoint,Text)>0) then Key:=#0;
   if not(Key in ['0'..'9',#8,#13,DecPoint]) then Key:=#0;
   if (SelLength=0) or (Pos(DecPoint,Text)in [SelStart..SelStart+SelLength]) then begin
      if (Pos(DecPoint,Text)>0) then begin
      if (Key in ['0'..'9']) and (Length(Text)-Pos(DecPoint,Text)>=FDecimals)
         and (SelStart>=Pos(DecPoint,Text)) then
         Key:=#0;
      end;
      if (Key in ['0'..'9']) then begin
         if (Pos(DecPoint,Text)>0) and (Pos(DecPoint,Text)>FIntLen) and (SelStart<Pos(DecPoint,Text))
            then Key:=#0;
         if (Pos(DecPoint,Text)=0) and (Length(Text)=FIntLen)
            then Key:=#0;
      end;
   end; {SelLength=0}
   inherited KeyPress(Key);
end;

function TEditReal.SetText(Txt : String):boolean;
var i:integer;
    Txt2:string;
begin
   Txt2:='';
   for i:=1 to length(Txt) do
      if Txt[i] in ['0'..'9',DecPoint] then Txt2:=Txt2+Txt[i];
   if Pos(DecPoint,Txt2)>0 then begin
      if (Length(Txt2)-Pos(DecPoint,Txt2))>Decimals then
         Delete(Txt2,Pos(DecPoint,Txt2)+Decimals,Length(Txt2)-Pos(DecPoint,Txt2)+Decimals);
   end;
   if Pos(DecPoint,Txt2)>IntLen then Txt2:='';
   Text:=Txt2;
   If Txt2=Txt then SetText:=true else SetText:=false;
end;

procedure Register;
begin
  RegisterComponents('Milka', [TEditReal]);
end;

end.
